!=======================================================================================
!
!Copyright 2013 Ibero Rubik
!
!This file is part of Ibero Solver 2x2x2 LBL.
!
!Ibero Solver 2x2x2 LBL is free software: you can redistribute it and/or modify
!it under the terms of the GNU General Public License as published by
!the Free Software Foundation, either version 3 of the License, or
!any later version.
!
!Ibero Solver 2x2x2 LBL is distributed in the hope that it will be useful,
!but WITHOUT ANY WARRANTY; without even the implied warranty of
!MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!GNU General Public License for more details.
!
!You should have received a copy of the GNU General Public License
!along with Ibero Solver 2x2x2 LBL.  If not, see <http://www.gnu.org/licenses/>.
!
!=======================================================================================


program LBL_Fortran_Solver_2x2x2

	use subrutinas_2x2x2_LBL_Fortran_Solver_1
	use subrutinas_2x2x2_LBL_Fortran_Solver_2
	use subrutinas_2x2x2_LBL_Fortran_Solver_3

	implicit none

	integer	:: u1, u2, u3, u4, u5, u6, u7, u11, u12, u13, u14, u15, error, i, j, k, n, step, numero_reduccion

	character(len=10)	:: MU(2,2), MF(2,2), MR(2,2), MB(2,2), ML(2,2), MD(2,2)
	real(8)				:: ti, tf, dt

	call cpu_time(ti)

	u1 = 101
	u2 = 102
	u3 = 103
	u4 = 104
	u5 = 105
	u6 = 106
	u7 = 201
	
	u11 = 301
	u12 = 302
	u13 = 303
	u14 = 304
	u15 = 305
	
	
	
	!--------------------------------------------------------------------------------
	!Apertura de los ficheros para eliminar su contenido
	!--------------------------------------------------------------------------------
	
	open (unit = u7, file = "archivos_de_programa/errores.txt", status = 'replace', action = 'write', iostat = error)
	
	open (unit = u11, file = 'resultados/movimientos_paso_0.txt', status = 'replace', action = 'write', iostat = error)
	open (unit = u12, file = 'resultados/movimientos_paso_1.txt', status = 'replace', action = 'write', iostat = error)
	open (unit = u13, file = 'resultados/movimientos_paso_2.txt', status = 'replace', action = 'write', iostat = error)
	open (unit = u14, file = 'resultados/movimientos_paso_3.txt', status = 'replace', action = 'write', iostat = error)
	open (unit = u15, file = 'resultados/movimientos.txt', status = 'replace', action = 'write', iostat = error)
	
	close(u11)
	close(u12)
	close(u13)
	close(u14)
	close(u15)
	

	!--------------------------------------------------------------------------------
	!Carga de las caras
	!--------------------------------------------------------------------------------
	open (unit = u1, file = "caras/U.txt", status = 'unknown', action = 'read', iostat = error)
	if (error > 0) then
		write(u7,*) 'el fichero "caras/U.txt" no se ha abierto correctamente'
		stop 'el fichero "caras/U.txt" no se ha abierto correctamente'
	end if
		 
	rewind (u1)

	read (u1, *) MU(1,1), MU(1,2)
	read (u1, *) MU(2,1), MU(2,2)

	close (u1)

	open (unit = u2, file = "caras/F.txt", status = 'unknown', action = 'read', iostat = error)
	if (error > 0) then
		write(u7,*) 'el fichero "caras/F.txt" no se ha abierto correctamente'
		stop 'el fichero "caras/F.txt" no se ha abierto correctamente'
	end if
		 
	rewind (u2)

	read (u2, *) MF(1,1), MF(1,2)
	read (u2, *) MF(2,1), MF(2,2)

	close (u2)

	open (unit = u3, file = "caras/R.txt", status = 'unknown', action = 'read', iostat = error)
	if (error > 0) then
		write(u7,*) 'el fichero "caras/R.txt" no se ha abierto correctamente'
		stop 'el fichero "caras/R.txt" no se ha abierto correctamente'
	end if
		 
	rewind (u3)

	read (u3, *) MR(1,1), MR(1,2)
	read (u3, *) MR(2,1), MR(2,2)

	close (u3)

	open (unit = u4, file = "caras/B.txt", status = 'unknown', action = 'read', iostat = error)
	if (error > 0) then
		write(u7,*) 'el fichero "caras/B.txt" no se ha abierto correctamente'
		stop 'el fichero "caras/B.txt" no se ha abierto correctamente'
	end if
		 
	rewind (u4)

	read (u4, *) MB(1,1), MB(1,2)
	read (u4, *) MB(2,1), MB(2,2)

	close (u4)

	open (unit = u5, file = "caras/L.txt", status = 'unknown', action = 'read', iostat = error)
	if (error > 0) then
		write(u7,*) 'el fichero "caras/L.txt" no se ha abierto correctamente'
		stop 'el fichero "caras/L.txt" no se ha abierto correctamente'
	end if
		 
	rewind (u5)

	read (u5, *) ML(1,1), ML(1,2)
	read (u5, *) ML(2,1), ML(2,2)

	close (u6)

	open (unit = u6, file = "caras/D.txt", status = 'unknown', action = 'read', iostat = error)
	if (error > 0) then
		write(u7,*) 'el fichero "caras/D.txt" no se ha abierto correctamente'
		stop 'el fichero "caras/D.txt" no se ha abierto correctamente'
	end if
		 
	rewind (u6)

	read (u6, *) MD(1,1), MD(1,2)
	read (u6, *) MD(2,1), MD(2,2)

	close (u6)
	
	close (u7)
	
	write(*,*) ' '
	write(*,*) 'Los datos escritos en los ficheros de las caras son los siguientes:'
	
	write(*,*) '----------------------------'
	write(*,*) 'U'
	do i = 1, 2
		write(*,*) (MU(i,j), j = 1,2)
	end do
	write(*,*) '----------------------------'
	
	write(*,*) '----------------------------'
	write(*,*) 'F'
	do i = 1, 2
		write(*,*) (MF(i,j), j = 1,2)
	end do
	write(*,*) '----------------------------'

	write(*,*) '----------------------------'
	write(*,*) 'R'
	do i = 1, 2
		write(*,*) (MR(i,j), j = 1,2)
	end do
	write(*,*) '----------------------------'
	
	write(*,*) '----------------------------'
	write(*,*) 'B'
	do i = 1, 2
		write(*,*) (MB(i,j), j = 1,2)
	end do
	write(*,*) '----------------------------'
	
	write(*,*) '----------------------------'
	write(*,*) 'L'
	do i = 1, 2
		write(*,*) (ML(i,j), j = 1,2)
	end do
	write(*,*) '----------------------------'
	
	write(*,*) '----------------------------'
	write(*,*) 'D'
	do i = 1, 2
		write(*,*) (MD(i,j), j = 1,2)
	end do
	write(*,*) '----------------------------'
	
	write(*,*) ' '
	
	!--------------------------------------------------------------------------------
	!Deteccion del patron de colores
	!--------------------------------------------------------------------------------
	
	call patron_colores (MU = MU, MF = MF, MR = MR, MB = MB, ML = ML, MD = MD)
	
	!--------------------------------------------------------------------------------
	!Deteccion de fallos en la escritura de los colores
	!--------------------------------------------------------------------------------
	
	call deteccion_de_fallos (MU = MU, MF = MF, MR = MR, MB = MB, ML = ML, MD = MD)
	
	!--------------------------------------------------------------------------------
	!Deteccion de la etapa
	!--------------------------------------------------------------------------------
	
	call detector_de_etapa (MU = MU, MF = MF, MR = MR, MB = MB, ML = ML, MD = MD, n = n, step = step)
	
	!--------------------------------------------------------------------------------
	!cambio interno de color
	!--------------------------------------------------------------------------------
	
	call cambio_de_color (MU = MU, MF = MF, MR = MR, MB = MB, ML = ML, MD = MD, n = n)
	
	!--------------------------------------------------------------------------------
	!resolucion
	!--------------------------------------------------------------------------------
	
	
	if (step == 1) then
	
		call solve_step_1 (MU = MU, MF = MF, MR = MR, MB = MB, ML = ML, MD = MD, n = n)
		call solve_step_2 (MU = MU, MF = MF, MR = MR, MB = MB, ML = ML, MD = MD)
		call solve_step_3 (MU = MU, MF = MF, MR = MR, MB = MB, ML = ML, MD = MD)
		
	else if (step == 2) then
	
		call solve_step_2 (MU = MU, MF = MF, MR = MR, MB = MB, ML = ML, MD = MD)
		call solve_step_3 (MU = MU, MF = MF, MR = MR, MB = MB, ML = ML, MD = MD)
		
	else if (step == 3) then
	
		call solve_step_3 (MU = MU, MF = MF, MR = MR, MB = MB, ML = ML, MD = MD)
		
	else if (step == 4) then
	
		write(*,*) 'El cubo ya esta resuelto, no es necesario resolverlo'
		
	end if

	!--------------------------------------------------------------------------------
	!creacion del fichero global de movimientos
	!--------------------------------------------------------------------------------
	
	call join_files
	
	!--------------------------------------------------------------------------------
	!reduccion de movimientos
	!--------------------------------------------------------------------------------
	
	
	
	call reductor_de_movimientos	(nombre_fichero_entrada = 'resultados/movimientos.txt', &
									&nombre_fichero_salida = 'resultados/movimientos.txt', &
									&numero_reduccion = numero_reduccion)
									
	write(*,*) 'Primera ejecucion de "reductor_de_movimientos", reduccion: ', numero_reduccion
									
	call reductor_de_movimientos	(nombre_fichero_entrada = 'resultados/movimientos.txt', &
									&nombre_fichero_salida = 'resultados/movimientos.txt', &
									&numero_reduccion = numero_reduccion)

	write(*,*) 'Segunda ejecucion de "reductor_de_movimientos", reduccion: ', numero_reduccion
									
	call reductor_de_movimientos	(nombre_fichero_entrada = 'resultados/movimientos.txt', &
									&nombre_fichero_salida = 'resultados/movimientos.txt', &
									&numero_reduccion = numero_reduccion)

	write(*,*) 'Tercera ejecucion de "reductor_de_movimientos", reduccion: ', numero_reduccion
	
	write(*,*) ' '

	!--------------------------------------------------------------------------------
	!calculo del tiempo de ejecucion
	!--------------------------------------------------------------------------------
	
	call cpu_time(tf)
	
	write(*,*) 'el instante inicial es: ', ti
	write(*,*) 'el instante final es: ', tf
	dt = tf - ti
	write(*,*) 'el programa ha tardado en resolver el cubo ', dt, ' segundos'
	
	write(*,*) ' '
	
	write(*,*) 'Pulse cualquier tecla y presione ENTER para cerrar el programa'
	read(*,*)
	
end program LBL_Fortran_Solver_2x2x2
