!=======================================================================================
!
!Copyright 2013 Ibero Rubik
!
!This file is part of Ibero Solver 2x2x2 LBL.
!
!Ibero Solver 2x2x2 LBL is free software: you can redistribute it and/or modify
!it under the terms of the GNU General Public License as published by
!the Free Software Foundation, either version 3 of the License, or
!any later version.
!
!Ibero Solver 2x2x2 LBL is distributed in the hope that it will be useful,
!but WITHOUT ANY WARRANTY; without even the implied warranty of
!MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!GNU General Public License for more details.
!
!You should have received a copy of the GNU General Public License
!along with Ibero Solver 2x2x2 LBL.  If not, see <http://www.gnu.org/licenses/>.
!
!=======================================================================================


module subrutinas_2x2x2_LBL_Fortran_Solver_1

	use subrutinas_2x2x2_LBL_Fortran_Solver_3

	implicit none
	
	contains
	
	!______________________________________________________________________
	
		subroutine patron_colores (MU, MF, MR, MB, ML, MD)
		
			character (len=10), intent(inout)	:: MU(2,2), MF(2,2), MR(2,2), MB(2,2), ML(2,2), MD(2,2)
			
			integer				:: i, j
			character (len=10)	:: supermatriz (2,12)
			
			supermatriz (:,1:2) = MU
			supermatriz (:,3:4) = MF
			supermatriz (:,5:6) = MR
			supermatriz (:,7:8) = MB
			supermatriz (:,9:10) = ML
			supermatriz (:,11:12) = MD
			
			do i = 1, 2
			
				do j = 1, 12
				
					if (supermatriz(i,j) == 'purple') then
					
						supermatriz (i,j) = 'orange'
						
					else if (supermatriz(i,j) == 'black') then
					
						supermatriz (i,j) = 'white'
					
					end if
					
				end do
				
			end do
			
			MU = supermatriz (:,1:2)
			MF = supermatriz (:,3:4)
			MR = supermatriz (:,5:6)
			MB = supermatriz (:,7:8)
			ML = supermatriz (:,9:10)
			MD = supermatriz (:,11:12)
			
			write (*,*) 'Despues de la deteccion del patron, las caras quedan:'
	
			write(*,*) '----------------------------'
			write(*,*) 'U'
			do i = 1, 2
				write(*,*) (MU(i,j), j = 1,2)
			end do
			write(*,*) '----------------------------'
			
			write(*,*) '----------------------------'
			write(*,*) 'F'
			do i = 1, 2
				write(*,*) (MF(i,j), j = 1,2)
			end do
			write(*,*) '----------------------------'

			write(*,*) '----------------------------'
			write(*,*) 'R'
			do i = 1, 2
				write(*,*) (MR(i,j), j = 1,2)
			end do
			write(*,*) '----------------------------'
			
			write(*,*) '----------------------------'
			write(*,*) 'B'
			do i = 1, 2
				write(*,*) (MB(i,j), j = 1,2)
			end do
			write(*,*) '----------------------------'
			
			write(*,*) '----------------------------'
			write(*,*) 'L'
			do i = 1, 2
				write(*,*) (ML(i,j), j = 1,2)
			end do
			write(*,*) '----------------------------'
			
			write(*,*) '----------------------------'
			write(*,*) 'D'
			do i = 1, 2
				write(*,*) (MD(i,j), j = 1,2)
			end do
			write(*,*) '----------------------------'
			
			write(*,*) ' '
			
		end subroutine patron_colores

	!______________________________________________________________________
	
	subroutine deteccion_de_fallos (MU, MF, MR, MB, ML, MD)
		
			character (len=10), intent(inout)	:: MU(2,2), MF(2,2), MR(2,2), MB(2,2), ML(2,2), MD(2,2)
			
			integer				:: i, j, num(6), u7, error
			character (len=10)	:: supermatriz (2,12)
			
			u7 = 200
			
			open (unit = u7, file = 'archivos_de_programa/errores.txt', status = 'unknown', action = 'write', iostat = error)
			
			supermatriz (:,1:2) = MU
			supermatriz (:,3:4) = MF
			supermatriz (:,5:6) = MR
			supermatriz (:,7:8) = MB
			supermatriz (:,9:10) = ML
			supermatriz (:,11:12) = MD
			
			num = 0
			
			do i = 1, 2
			
				do j = 1, 12
				
					if ((supermatriz(i,j) /= 'white').and.(supermatriz(i,j) /= 'red').and.(supermatriz(i,j) /= 'blue')&
					&.and.(supermatriz(i,j) /= 'orange').and.(supermatriz(i,j) /= 'green').and.(supermatriz(i,j) /= 'yellow')) then
						
						write(u7,*) 'Algun color de las caras no esta escrito correctamente'
						write(*,*) 'Algun color de las caras no esta escrito correctamente'
						stop
					
					end if
					
					select case (supermatriz(i,j))
					
						case ('white')
							num(1) = num(1) + 1
						case ('red')
							num(2) = num(2) + 1	
						case ('blue')
							num(3) = num(3) + 1	
						case ('orange')
							num(4) = num(4) + 1	
						case ('green')
							num(5) = num(5) + 1
						case ('yellow')
							num(6) = num(6) + 1
							
					end select
					
				end do
				
			end do
			
			if (any (num /= 4)) then
			
				write(u7,*) 'Algun color ha sido escrito mas de cuatro veces'
				write(*,*) 'Algun color ha sido escrito mas de cuatro veces'
				stop
				
			end if
	
	end subroutine deteccion_de_fallos
	
	
	!______________________________________________________________________
	
		subroutine detector_de_etapa (MU, MF, MR, MB, ML, MD, n, step)
		
			character (len=10), intent(inout)	:: MU(2,2), MF(2,2), MR(2,2), MB(2,2), ML(2,2), MD(2,2)
			integer, intent(out)				:: n, step
			
			integer								:: i, j, u1, u7, error
			character(len=10)					:: supermatriz(2,12)
			
			
			n	= 0
			u1	= 201
			u7	= 202
			
			open (unit = u7, file = "archivos_de_programa/errores.txt", status = 'unknown', action = 'write', iostat = error)
			
			!------------------------------------------------------------------------------------
			!1 parte; deteccion de la cara mas completa para colocarla en la parte superior
			!------------------------------------------------------------------------------------
			
			open (unit = u1, file = 'resultados/movimientos_paso_0.txt', status = 'replace', action = 'write', iostat = error)
			if (error > 0) then
				write(u7,*) 'subroutine detector_de_etapa: el fichero "resultados/movimientos_paso_0.txt" no se ha abierto correctamente'
				stop 'subroutine detector_de_etapa: el fichero "resultados/movimientos_paso_0.txt" no se ha abierto correctamente'
			end if
			
			if ((MU(1,1)==MU(1,2)).and.(MU(1,1)==MU(2,1)).and.(MU(1,1)==MU(2,2))) then
			
				n = 4
				
			else if ((MF(1,1)==MF(1,2)).and.(MF(1,1)==MF(2,1)).and.(MF(1,1)==MF(2,2))) then
			
				n = 4
				call x (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				write(u1,*) "x"
				
			else if ((MR(1,1)==MR(1,2)).and.(MR(1,1)==MR(2,1)).and.(MR(1,1)==MR(2,2))) then
			
				n = 4
				call z_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				write(u1,*) "z'"
				
			else if ((MB(1,1)==MB(1,2)).and.(MB(1,1)==MB(2,1)).and.(MB(1,1)==MB(2,2))) then
			
				n = 4
				call x_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				write(u1,*) "x'"
				
			else if ((ML(1,1)==ML(1,2)).and.(ML(1,1)==ML(2,1)).and.(ML(1,1)==ML(2,2))) then
			
				n = 4
				call z (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				write(u1,*) "z"
				
			else if ((MD(1,1)==MD(1,2)).and.(MD(1,1)==MD(2,1)).and.(MD(1,1)==MD(2,2))) then
			
				n = 4
				call x_2 (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				write(u1,*) "x2"
				
			else if (((MU(1,1)==MU(1,2)).and.(MU(1,1)==MU(2,1)))&
				&.or.((MU(1,1)==MU(1,2)).and.(MU(1,1)==MU(2,2)))&
				&.or.((MU(1,1)==MU(2,1)).and.(MU(1,1)==MU(2,2)))&
				&.or.((MU(1,2)==MU(2,1)).and.(MU(1,2)==MU(2,2)))) then
				
				n = 3
				
			else if (((MF(1,1)==MF(1,2)).and.(MF(1,1)==MF(2,1)))&
				&.or.((MF(1,1)==MF(1,2)).and.(MF(1,1)==MF(2,2)))&
				&.or.((MF(1,1)==MF(2,1)).and.(MF(1,1)==MF(2,2)))&
				&.or.((MF(1,2)==MF(2,1)).and.(MF(1,2)==MF(2,2)))) then
				
				n = 3
				call x (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				write(u1,*) "x"
				
			else if (((MR(1,1)==MR(1,2)).and.(MR(1,1)==MR(2,1)))&
				&.or.((MR(1,1)==MR(1,2)).and.(MR(1,1)==MR(2,2)))&
				&.or.((MR(1,1)==MR(2,1)).and.(MR(1,1)==MR(2,2)))&
				&.or.((MR(1,2)==MR(2,1)).and.(MR(1,2)==MR(2,2)))) then
				
				n = 3
				call z_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				write(u1,*) "z'"
				
			else if (((MB(1,1)==MB(1,2)).and.(MB(1,1)==MB(2,1)))&
				&.or.((MB(1,1)==MB(1,2)).and.(MB(1,1)==MB(2,2)))&
				&.or.((MB(1,1)==MB(2,1)).and.(MB(1,1)==MB(2,2)))&
				&.or.((MB(1,2)==MB(2,1)).and.(MB(1,2)==MB(2,2)))) then
				
				n = 3
				call x_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				write(u1,*) "x'"
				
			else if (((ML(1,1)==ML(1,2)).and.(ML(1,1)==ML(2,1)))&
				&.or.((ML(1,1)==ML(1,2)).and.(ML(1,1)==ML(2,2)))&
				&.or.((ML(1,1)==ML(2,1)).and.(ML(1,1)==ML(2,2)))&
				&.or.((ML(1,2)==ML(2,1)).and.(ML(1,2)==ML(2,2)))) then
				
				n = 3
				call z (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				write(u1,*) "z"
				
			else if (((MD(1,1)==MD(1,2)).and.(MD(1,1)==MD(2,1)))&
				&.or.((MD(1,1)==MD(1,2)).and.(MD(1,1)==MD(2,2)))&
				&.or.((MD(1,1)==MD(2,1)).and.(MD(1,1)==MD(2,2)))&
				&.or.((MD(1,2)==MD(2,1)).and.(MD(1,2)==MD(2,2)))) then
				
				n = 3
				call x_2 (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				write(u1,*) "x2"
				
			else			!No se han localizado 4 o 3 colores iguales juntos; se gira el cubo para que haya algun blanco arriba
				
				if (any(MU == 'white')) then
					n = 1
				else if (any(MF == 'white')) then
					n = 1
					call x (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
					write(u1,*) "x"
				else if (any(MR == 'white')) then
					n = 1
					call z_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
					write(u1,*) "z'"
				else if (any(MB == 'white')) then
					n = 1
					call x_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
					write(u1,*) "x'"
				else if (any(ML == 'white')) then
					n = 1
					call z (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
					write(u1,*) "z"
				end if

			end if
			
	
			
			!------------------------------------------------------------------------------------
			!2 parte; determinacion de cuan resuelto esta el cubo
			!------------------------------------------------------------------------------------
				
			if (n == 4) then
			
				if ((MF(1,1) == MF(1,2)).and.(MR(1,1) == MR(1,2)).and.(MB(1,1) == MB(1,2)).and.(ML(1,1) == ML(1,2))) then
				
					if ( (MF(1,1)==MF(2,1)).and.(MF(1,2)==MF(2,2)).and.(MR(1,1)==MR(2,1)).and.(MR(1,2)==MR(2,2))&
					&.and.(MB(1,1)==MB(2,1)).and.(MB(1,2)==MB(2,2)).and.(ML(1,1)==ML(2,1)).and.(ML(1,2)==ML(2,2)) ) then
					
						step = 4
						
					else if ( (MD(1,1)==MD(1,2)).and.(MD(1,1)==MD(2,1)).and.(MD(1,1)==MD(2,2)) ) then
					
						step = 3
						
					else
				
						step = 2
						
					end if
					
				else
					step = 1
					
				end if
				
			else
			
				step = 1
				
			end if
			
			write (*,*) 'Despues del giro del cubo y la deteccion de etapa, las caras quedan:'
	
			write(*,*) '----------------------------'
			write(*,*) 'U'
			do i = 1, 2
				write(*,*) (MU(i,j), j = 1,2)
			end do
			write(*,*) '----------------------------'
			
			write(*,*) '----------------------------'
			write(*,*) 'F'
			do i = 1, 2
				write(*,*) (MF(i,j), j = 1,2)
			end do
			write(*,*) '----------------------------'

			write(*,*) '----------------------------'
			write(*,*) 'R'
			do i = 1, 2
				write(*,*) (MR(i,j), j = 1,2)
			end do
			write(*,*) '----------------------------'
			
			write(*,*) '----------------------------'
			write(*,*) 'B'
			do i = 1, 2
				write(*,*) (MB(i,j), j = 1,2)
			end do
			write(*,*) '----------------------------'
			
			write(*,*) '----------------------------'
			write(*,*) 'L'
			do i = 1, 2
				write(*,*) (ML(i,j), j = 1,2)
			end do
			write(*,*) '----------------------------'
			
			write(*,*) '----------------------------'
			write(*,*) 'D'
			do i = 1, 2
				write(*,*) (MD(i,j), j = 1,2)
			end do
			write(*,*) '----------------------------'
			
			write(*,*) ' '
			
			
		end subroutine detector_de_etapa
		
	!______________________________________________________________________		
		
		subroutine cambio_de_color (MU, MF, MR, MB, ML, MD, n)
		
			character (len=10), intent(inout)	:: MU(2,2), MF(2,2), MR(2,2), MB(2,2), ML(2,2), MD(2,2)
			integer, intent(in)					:: n
			
			integer								:: i, j
			character(len=10)					:: supermatriz(2,12), color_superior
		
			color_superior = 'white'
			
			if (n == 4) then

				color_superior	= MU(1,1)
				
			else if (n == 3) then
			
				if (MU(1,1) == MU(1,2)) then
					color_superior = MU(1,1)
				else
					color_superior = MU(2,1)
				end if
				
			end if
			
			supermatriz (:,1:2) = MU
			supermatriz (:,3:4) = MF
			supermatriz (:,5:6) = MR
			supermatriz (:,7:8) = MB
			supermatriz (:,9:10) = ML
			supermatriz (:,11:12) = MD
			
			select case (color_superior)
			
				case ('red')
				
				do i = 1, 2				
					do j = 1, 12					
						if (supermatriz(i,j) == 'red') then						
							supermatriz(i,j) = 'white'							
						else if (supermatriz(i,j) == 'white') then						
							supermatriz(i,j) = 'red'
						else if (supermatriz(i,j) == 'green') then						
							supermatriz(i,j) = 'blue'
						else if (supermatriz(i,j) == 'yellow') then						
							supermatriz(i,j) = 'orange'
						else if (supermatriz(i,j) == 'blue') then						
							supermatriz(i,j) = 'green'
						else if (supermatriz(i,j) == 'orange') then						
							supermatriz(i,j) = 'yellow'
						end if
					end do
				end do
				
				case ('blue')
				
				do i = 1, 2				
					do j = 1, 12					
						if (supermatriz(i,j) == 'blue') then						
							supermatriz(i,j) = 'white'							
						else if (supermatriz(i,j) == 'white') then						
							supermatriz(i,j) = 'red'
						else if (supermatriz(i,j) == 'red') then						
							supermatriz(i,j) = 'blue'
						else if (supermatriz(i,j) == 'yellow') then						
							supermatriz(i,j) = 'orange'
						else if (supermatriz(i,j) == 'orange') then						
							supermatriz(i,j) = 'green'
						else if (supermatriz(i,j) == 'orange') then						
							supermatriz(i,j) = 'yellow'
						end if
					end do
				end do
				
				case ('orange')
				
				do i = 1, 2				
					do j = 1, 12					
						if (supermatriz(i,j) == 'orange') then						
							supermatriz(i,j) = 'white'							
						else if (supermatriz(i,j) == 'white') then						
							supermatriz(i,j) = 'red'
						else if (supermatriz(i,j) == 'blue') then						
							supermatriz(i,j) = 'blue'
						else if (supermatriz(i,j) == 'yellow') then						
							supermatriz(i,j) = 'orange'
						else if (supermatriz(i,j) == 'green') then						
							supermatriz(i,j) = 'green'
						else if (supermatriz(i,j) == 'red') then						
							supermatriz(i,j) = 'yellow'
						end if
					end do
				end do
				
				case ('green')
				
				do i = 1, 2				
					do j = 1, 12					
						if (supermatriz(i,j) == 'green') then						
							supermatriz(i,j) = 'white'							
						else if (supermatriz(i,j) == 'white') then						
							supermatriz(i,j) = 'red'
						else if (supermatriz(i,j) == 'orange') then						
							supermatriz(i,j) = 'blue'
						else if (supermatriz(i,j) == 'yellow') then						
							supermatriz(i,j) = 'orange'
						else if (supermatriz(i,j) == 'red') then						
							supermatriz(i,j) = 'green'
						else if (supermatriz(i,j) == 'blue') then						
							supermatriz(i,j) = 'yellow'
						end if
					end do
				end do
			
				case ('yellow')
				
				do i = 1, 2				
					do j = 1, 12					
						if (supermatriz(i,j) == 'yellow') then						
							supermatriz(i,j) = 'white'							
						else if (supermatriz(i,j) == 'red') then						
							supermatriz(i,j) = 'red'
						else if (supermatriz(i,j) == 'green') then						
							supermatriz(i,j) = 'blue'
						else if (supermatriz(i,j) == 'orange') then						
							supermatriz(i,j) = 'orange'
						else if (supermatriz(i,j) == 'blue') then						
							supermatriz(i,j) = 'green'
						else if (supermatriz(i,j) == 'white') then						
							supermatriz(i,j) = 'yellow'
						end if
					end do
				end do
				
			end select
				
			MU = supermatriz (:,1:2)
			MF = supermatriz (:,3:4)
			MR = supermatriz (:,5:6)
			MB = supermatriz (:,7:8)
			ML = supermatriz (:,9:10)
			MD = supermatriz (:,11:12)
			
			write (*,*) 'Despues del cambio interno de color, las caras quedan:'
	
			write(*,*) '----------------------------'
			write(*,*) 'U'
			do i = 1, 2
				write(*,*) (MU(i,j), j = 1,2)
			end do
			write(*,*) '----------------------------'
			
			write(*,*) '----------------------------'
			write(*,*) 'F'
			do i = 1, 2
				write(*,*) (MF(i,j), j = 1,2)
			end do
			write(*,*) '----------------------------'

			write(*,*) '----------------------------'
			write(*,*) 'R'
			do i = 1, 2
				write(*,*) (MR(i,j), j = 1,2)
			end do
			write(*,*) '----------------------------'
			
			write(*,*) '----------------------------'
			write(*,*) 'B'
			do i = 1, 2
				write(*,*) (MB(i,j), j = 1,2)
			end do
			write(*,*) '----------------------------'
			
			write(*,*) '----------------------------'
			write(*,*) 'L'
			do i = 1, 2
				write(*,*) (ML(i,j), j = 1,2)
			end do
			write(*,*) '----------------------------'
			
			write(*,*) '----------------------------'
			write(*,*) 'D'
			do i = 1, 2
				write(*,*) (MD(i,j), j = 1,2)
			end do
			write(*,*) '----------------------------'
			
			write(*,*) ' '
	
		end subroutine cambio_de_color
		
	!______________________________________________________________________
		
		subroutine join_files
		
			integer 			:: u0, u1, u2, u3, u4, u7, error
			character(len=10)	:: movimiento
			
			u0 = 101
			u1 = 102
			u2 = 103
			u3 = 104
			u4 = 201
			u7 = 202
			
			open (unit = u7, file = "archivos_de_programa/errores.txt", status = 'unknown', action = 'write', iostat = error)
			
			open (unit = u0, file = 'resultados/movimientos_paso_0.txt', status = 'unknown', action = 'read', iostat = error)
			if (error > 0) then
				write(u7,*) 'subroutine join_files: el fichero "resultados/movimientos_paso_0.txt" no se ha abierto correctamente'
				stop 'subroutine join_files: el fichero "resultados/movimientos_paso_0.txt" no se ha abierto correctamente'
			end if
			
			open (unit = u1, file = 'resultados/movimientos_paso_1.txt', status = 'unknown', action = 'read', iostat = error)
			if (error > 0) then
				write(u7,*) 'subroutine join_files: el fichero "resultados/movimientos_paso_1.txt" no se ha abierto correctamente'
				stop 'subroutine join_files: el fichero "resultados/movimientos_paso_1.txt" no se ha abierto correctamente'
			end if
			
			open (unit = u2, file = 'resultados/movimientos_paso_2.txt', status = 'unknown', action = 'read', iostat = error)
			if (error > 0) then
				write(u7,*) 'subroutine join_files: el fichero "resultados/movimientos_paso_2.txt" no se ha abierto correctamente'
				stop 'subroutine join_files: el fichero "resultados/movimientos_paso_2.txt" no se ha abierto correctamente'
			end if
			
			open (unit = u3, file = 'resultados/movimientos_paso_3.txt', status = 'unknown', action = 'read', iostat = error)
			if (error > 0) then
				write(u7,*) 'subroutine join_files: el fichero "resultados/movimientos_paso_3.txt" no se ha abierto correctamente'
				stop 'subroutine join_files: el fichero "resultados/movimientos_paso_3.txt" no se ha abierto correctamente'
			end if
			
			open (unit = u4, file = 'resultados/movimientos.txt', status = 'replace', action = 'write', iostat = error)
			if (error > 0) then
				write(u7,*) 'subroutine join_files: el fichero "resultados/movimientos.txt" no se ha abierto correctamente'
				stop 'subroutine join_files: el fichero "resultados/movimientos.txt" no se ha abierto correctamente'
			end if
			
			do
			
				read(u0,*,iostat=error) movimiento
				if (error < 0) exit
				write(u4,*) movimiento
				
			end do
			
			do
			
				read(u1,*,iostat=error) movimiento
				if (error < 0) exit
				write(u4,*) movimiento
				
			end do
			
			do
			
				read(u2,*,iostat=error) movimiento
				if (error < 0) exit
				write(u4,*) movimiento
				
			end do
			
			do
			
				read(u3,*,iostat=error) movimiento
				if (error < 0) exit
				write(u4,*) movimiento
				
			end do
			
			
			close (u4)
				
			
			
		
		end subroutine join_files
		
	!______________________________________________________________________		
		
		subroutine reductor_de_movimientos (nombre_fichero_entrada, nombre_fichero_salida, numero_reduccion)
		
			character(len=*), intent(in)	:: nombre_fichero_entrada, nombre_fichero_salida
			integer, intent(out)			:: numero_reduccion
			
			integer							:: i, j, k, u1, u2, u7, error, n
			character(len=2), allocatable	:: v(:), w(:), p1, p2
			character(len=15)				:: resultado
			
			u1 = 100
			u2 = 201
			u7 = 202
			
			
			
			open (unit = u7, file = "archivos_de_programa/errores.txt", status = 'unknown', action = 'write', iostat = error)
			
			open (unit = u1, file = nombre_fichero_entrada, status = 'unknown', action = 'read', iostat = error)
			if (error > 0) then
				write(u7,*) 'subroutine "reductor_de_movimientos": el fichero ', nombre_fichero_entrada, &
								&' no se ha abierto correctamente como archivo "read"'
				stop 'subroutine "reductor_de_movimientos": el fichero u1 no se ha abierto correctamente como archivo "read"'
			end if
								
			!Alocatacion de los vectores
			
			n = 0
			
			rewind(u1)
			
			do
			
				read(u1,*,iostat = error)
				if (error < 0) exit
				n = n + 1
			
			end do
			
			
			allocate (v(n), stat = error)
			if (error > 0) then
				write(u7,*) 'subroutine "reductor_de_movimientos": el vector "v" no se ha alocatado correctamente'
				stop 'subroutine "reductor_de_movimientos": el vector "v" no se ha alocatado correctamente'
			end if
			
			allocate (w(n), stat = error)
			if (error > 0) then
				write(u7,*) 'subroutine "reductor_de_movimientos": el vector "w" no se ha alocatado correctamente'
				stop 'subroutine "reductor_de_movimientos": el vector "w" no se ha alocatado correctamente'
			end if
			
			!Carga de los caracteres en el vector
			
			rewind(u1)
			
			do i = 1, n
			
				read(u1,*) v(i)
				
			end do
			
			close(u1)
			
			!Proceso de reduccion de caracteres
			
			i = 1
			j = 1
			
			do
			
				if (i == n) then
				
					w(j) = v(n)
					exit
					
				else if (i > n) then
				
					j = j - 1
					exit
					
				end if
		
				p1 = v(i)
				p2 = v(i+1)
				
				
				select case (p1)
				
					case ("U")
					
						call reducir(p2 = p2, fU = "U ", fU_prime = "U'", fU2 = "U2", fD_prime = "D'", fD = "D ", &
						&fy_prime = "y'", fy = "y ", resultado = resultado)	
					
					case ("F")
					
						call reducir(p2 = p2, fU = "F ", fU_prime = "F'", fU2 = "F2", fD_prime = "B'", fD = "B ", &
						&fy_prime = "z'", fy = "z ", resultado = resultado)
					
					case ("R")
					
						call reducir(p2 = p2, fU = "R ", fU_prime = "R'", fU2 = "R2", fD_prime = "L'", fD = "L ", &
						&fy_prime = "x'", fy = "x ", resultado = resultado)
					
					case ("B")
					
						call reducir(p2 = p2, fU = "B ", fU_prime = "B'", fU2 = "B2", fD_prime = "F'", fD = "F ", &
						&fy_prime = "z ", fy = "z'", resultado = resultado)
					
					case ("L")
					
						call reducir(p2 = p2, fU = "L ", fU_prime = "L'", fU2 = "L2", fD_prime = "R'", fD = "R ", &
						&fy_prime = "x ", fy = "x'", resultado = resultado)
					
					case ("D")
					
						call reducir(p2 = p2, fU = "D ", fU_prime = "D'", fU2 = "D2", fD_prime = "U'", fD = "U ", &
						&fy_prime = "y ", fy = "y'", resultado = resultado)
					
					case ("U'")
					
						call reducir_prime (p2 = p2, fU_prime = "U'", fU = "U ", fU2 = "U2", fD_prime = "D'", fD = "D ", &
						&fy_prime = "y'", fy = "y ", resultado = resultado)
					
					case ("F'")
					
						call reducir_prime (p2 = p2, fU_prime = "F'", fU = "F ", fU2 = "F2", fD_prime = "B'", fD = "B ", &
						&fy_prime = "z'", fy = "z ", resultado = resultado)
					
					case ("R'")
					
						call reducir_prime (p2 = p2, fU_prime = "R'", fU = "R ", fU2 = "R2", fD_prime = "L'", fD = "L ", &
						&fy_prime = "x'", fy = "x ", resultado = resultado)
					
					case ("B'")
					
						call reducir_prime (p2 = p2, fU_prime = "B'", fU = "B ", fU2 = "B2", fD_prime = "F'", fD = "F ", &
						&fy_prime = "z ", fy = "z'", resultado = resultado)
					
					case ("L'")
					
						call reducir_prime (p2 = p2, fU_prime = "L'", fU = "L ", fU2 = "L2", fD_prime = "R'", fD = "R ", &
						&fy_prime = "x ", fy = "x'", resultado = resultado)
					
					case ("D'")
					
						call reducir_prime (p2 = p2, fU_prime = "D'", fU = "D ", fU2 = "D2", fD_prime = "U'", fD = "U ", &
						&fy_prime = "y ", fy = "y'", resultado = resultado)
					
					case ("U2")
					
						call reducir_double (p2 = p2, fU2 = "U2", fU = "U ", fU_prime = "U'", fD2 = "D2", &
						&fy2 = "y2", resultado = resultado)
					
					case ("F2")
					
						call reducir_double (p2 = p2, fU2 = "F2", fU = "F ", fU_prime = "F'", fD2 = "B2", &
						&fy2 = "z2", resultado = resultado)
					
					case ("R2")
					
						call reducir_double (p2 = p2, fU2 = "R2", fU = "R ", fU_prime = "R'", fD2 = "L2", &
						&fy2 = "x2", resultado = resultado)
					
					case ("B2")
					
						call reducir_double (p2 = p2, fU2 = "B2", fU = "B ", fU_prime = "B'", fD2 = "F2", &
						&fy2 = "z2", resultado = resultado)
					
					case ("L2")
					
						call reducir_double (p2 = p2, fU2 = "L2", fU = "L ", fU_prime = "L'", fD2 = "R2", &
						&fy2 = "x2", resultado = resultado)
					
					case ("D2")
					
						call reducir_double (p2 = p2, fU2 = "D2", fU = "D ", fU_prime = "D'", fD2 = "U2", &
						&fy2 = "y2", resultado = resultado)
						
					case ("x")
						
						call reducir_axis (p2 = p2, fx = "x ", fx_prime = "x'", fx2 = "x2", fR = "R "&
						&, fR_prime = "R'", fL = "L ", fL_prime = "L'", resultado = resultado)
						
					case ("y")
						
						call reducir_axis (p2 = p2, fx = "y ", fx_prime = "y'", fx2 = "y2", fR = "U "&
						&, fR_prime = "U'", fL = "D ", fL_prime = "D'", resultado = resultado)
						
					case ("z")
						
						call reducir_axis (p2 = p2, fx = "z ", fx_prime = "z'", fx2 = "z2", fR = "F "&
						&, fR_prime = "F'", fL = "B ", fL_prime = "B'", resultado = resultado)
						
					case ("x'")
						
						call reducir_axis_prime (p2 = p2, fx_prime = "x'", fx = "x ", fx2 = "x2", fR = "R "&
						&, fR_prime = "R'", fL = "L ", fL_prime = "L'", resultado = resultado)
						
					case ("y'")
						
						call reducir_axis_prime (p2 = p2, fx_prime = "y'", fx = "y ", fx2 = "y2", fR = "U "&
						&, fR_prime = "U'", fL = "D ", fL_prime = "D'", resultado = resultado)
						
					case ("z'")
						
						call reducir_axis_prime (p2 = p2, fx_prime = "z'", fx = "z ", fx2 = "z2", fR = "F "&
						&, fR_prime = "F'", fL = "B ", fL_prime = "B'", resultado = resultado)
						
					case ("x2")
						
						call reducir_axis_double (p2 = p2, fx2 = "x2", fx = "x ", fx_prime = "x'"&
						&, fR2 = "R2", fL2 = "L2", resultado = resultado)
						
					case ("y2")
						
						call reducir_axis_double (p2 = p2, fx2 = "y2", fx = "y ", fx_prime = "y'"&
						&, fR2 = "U2", fL2 = "D2", resultado = resultado)
						
					case ("z2")
						
						call reducir_axis_double (p2 = p2, fx2 = "z2", fx = "z ", fx_prime = "z'"&
						&, fR2 = "F2", fL2 = "B2", resultado = resultado)
						
					
				
				end select
				
				
				if (resultado == "autoeliminado") then
				
					i = i + 2
					
					
				else if (resultado == "nulo") then
				
					w(j) = p1
					j = j + 1
					i = i + 1
					
				else
				
					w(j) = resultado
					j = j + 1
					i = i + 2
					
				end if
				
			
			end do
			
			numero_reduccion = n - j
			
			open (unit = u2, file = nombre_fichero_salida, status = 'unknown', action = 'write', iostat = error)
			if (error > 0) then
				write(u7,*) 'subroutine "reductor_de_movimientos": el fichero ', nombre_fichero_salida, &
								&' no se ha abierto correctamente como archivo "write"'
				stop 'subroutine "reductor_de_movimientos": el fichero u2 no se ha abierto correctamente como archivo "write"'
			end if
			
			do k = 1, j
			
				write(u2,*) trim(w(k))
				
			end do
			
			close (u2)
			
		end subroutine reductor_de_movimientos
		
	!______________________________________________________________________		
		
		subroutine reducir (p2, fU, fU_prime, fU2, fD_prime, fD, fy_prime, fy, resultado)

			character(len=2), intent(in)	:: p2, fU, fU_prime, fU2, fD_prime, fD, fy_prime, fy
			character(len=15), intent(out)	:: resultado
			
			
			if (p2 == fU) then
			
				resultado = fU2
				
			else if (p2 == fU_prime) then
			
				resultado = "autoeliminado"
				
			else if (p2 == fU2) then
			
				resultado = fU_prime
				
			else if (p2 == fD_prime) then
			
				resultado = fy
				
			else if (p2 == fy_prime) then
			
				resultado = fD
				
			else
			
				resultado = "nulo"
				
			end if
			
		end subroutine reducir
		
	!______________________________________________________________________	
		
		subroutine reducir_prime (p2, fU_prime, fU, fU2, fD_prime, fD, fy_prime, fy, resultado)

			character(len=2), intent(in)	:: p2, fU, fU_prime, fU2, fD_prime, fD, fy_prime, fy
			character(len=15), intent(out)	:: resultado
			
			
			if (p2 == fU) then
			
				resultado = "autoeliminado"
				
			else if (p2 == fU_prime) then
			
				resultado = fU2
				
			else if (p2 == fU2) then
			
				resultado = fU
				
			else if (p2 == fD) then
			
				resultado = fy_prime
				
			else if (p2 == fy) then
			
				resultado = fD_prime
				
			else
			
				resultado = "nulo"
				
			end if
			
		end subroutine reducir_prime
		
		!______________________________________________________________________		
		
		subroutine reducir_double (p2, fU2, fU, fU_prime, fD2, fy2, resultado)

			character(len=2), intent(in)	:: p2, fU, fU_prime, fU2, fD2, fy2
			character(len=15), intent(out)	:: resultado
			
			
			if (p2 == fU2) then
			
				resultado = "autoeliminado"
				
			else if (p2 == fU) then
			
				resultado = fU_prime
				
			else if (p2 == fU_prime) then
			
				resultado = fU
				
			else if (p2 == fD2) then
			
				resultado = fy2
				
			else if (p2 == fy2) then
			
				resultado = fD2
				
			else
			
				resultado = "nulo"
				
			end if
			
		end subroutine reducir_double
		
	!______________________________________________________________________	
		
		subroutine reducir_axis (p2, fx, fx_prime, fx2, fR, fR_prime, fL, fL_prime, resultado)

			character(len=2), intent(in)	:: p2, fx, fx_prime, fx2, fR, fR_prime, fL, fL_prime
			character(len=15), intent(out)	:: resultado
			
			
			if (p2 == fx) then
			
				resultado = fx2
				
			else if (p2 == fx_prime) then
			
				resultado = "autoeliminado"
				
			else if (p2 == fx2) then
			
				resultado = fx_prime
				
			else if (p2 == fR_prime) then
			
				resultado = fL_prime
				
			else if (p2 == fL) then
			
				resultado = fR
				
			else
			
				resultado = "nulo"
				
			end if
			
		end subroutine reducir_axis
		
	!______________________________________________________________________

		subroutine reducir_axis_prime (p2, fx_prime, fx, fx2, fR, fR_prime, fL, fL_prime, resultado)

			character(len=2), intent(in)	:: p2, fx, fx_prime, fx2, fR, fR_prime, fL, fL_prime
			character(len=15), intent(out)	:: resultado
			
			
			if (p2 == fx) then
			
				resultado = "autoeliminado"
				
			else if (p2 == fx_prime) then
			
				resultado = fx2
				
			else if (p2 == fx2) then
			
				resultado = fx
				
			else if (p2 == fR) then
			
				resultado = fL
				
			else if (p2 == fL_prime) then
			
				resultado = fR_prime
				
			else
			
				resultado = "nulo"
				
			end if
			
		end subroutine reducir_axis_prime
		
	!______________________________________________________________________

		subroutine reducir_axis_double (p2, fx2, fx, fx_prime, fR2, fL2, resultado)

			character(len=2), intent(in)	:: p2, fx, fx_prime, fx2, fR2, fL2
			character(len=15), intent(out)	:: resultado
			
			
			if (p2 == fx) then
			
				resultado = fx_prime
				
			else if (p2 == fx_prime) then
			
				resultado = fx
				
			else if (p2 == fx2) then
			
				resultado = "autoeliminado"
				
			else if (p2 == fR2) then
			
				resultado = fL2
				
			else if (p2 == fL2) then
			
				resultado = fR2
				
			else
			
				resultado = "nulo"
				
			end if
			
		end subroutine reducir_axis_double
		
		
	
end module subrutinas_2x2x2_LBL_Fortran_Solver_1	