!=======================================================================================
!
!Copyright 2013 Ibero Rubik
!
!This file is part of Ibero Solver 2x2x2 LBL.
!
!Ibero Solver 2x2x2 LBL is free software: you can redistribute it and/or modify
!it under the terms of the GNU General Public License as published by
!the Free Software Foundation, either version 3 of the License, or
!any later version.
!
!Ibero Solver 2x2x2 LBL is distributed in the hope that it will be useful,
!but WITHOUT ANY WARRANTY; without even the implied warranty of
!MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!GNU General Public License for more details.
!
!You should have received a copy of the GNU General Public License
!along with Ibero Solver 2x2x2 LBL.  If not, see <http://www.gnu.org/licenses/>.
!
!=======================================================================================


module subrutinas_2x2x2_LBL_Fortran_Solver_2

	use subrutinas_2x2x2_LBL_Fortran_Solver_3
	
	implicit none
	
	contains
	
		subroutine solve_step_1 (MU, MF, MR, MB, ML, MD, n)
		
			character (len=10), intent(inout)	:: MU(2,2), MF(2,2), MR(2,2), MB(2,2), ML(2,2), MD(2,2)
			integer, intent(in)					:: n
			
			integer								:: A, u1, u7, error, i, j
			
			
			u1 = 201
			u7 = 202
			
			open (unit = u7, file = "archivos_de_programa/errores.txt", status = 'unknown', action = 'write', iostat = error)
			
			open (unit = u1, file = 'resultados/movimientos_paso_1.txt', status = 'replace', action = 'write', iostat = error)
			if (error > 0) then
				write(u7,*) 'subroutine solve_step_1: el fichero "resultados/movimientos_paso_1.txt" no se ha abierto correctamente'
				stop 'subroutine solve_step_1: el fichero "resultados/movimientos_paso_1.txt" no se ha abierto correctamente'
			end if
			
			
			!------------------------------------------------------------------------------------
			!1 parte; subida de piezas blancas
			!------------------------------------------------------------------------------------
			
			
			if (n < 4) then
			
			
				do
				
					
					
					if (MU(1,1) /= 'white') then				
						call U_2 (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						write(u1,*) "U2"
					else if (MU(1,2) /= 'white') then				
						call U (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						write(u1,*) "U"
					else if (MU(2,1) /= 'white') then				
						call U_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						write(u1,*) "U'"
					else if (all(MU == 'white')) then				
						exit					
					end if
					
				
					
					if (any (MD == 'white')) then			!El blanco estaria en la cara inferior
					
						if (MD(1,1) == 'white') then		!Giro de la capa inferior hasta colocarlo al frente a la derecha
							call D (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
							write(u1,*) "D"
						else if (MD(2,1) == 'white') then				
							call D_2 (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
							write(u1,*) "D2"
						else if (MD(2,2) == 'white') then				
							call D_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
							write(u1,*) "D'"
						end if
						
						call R_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						call D (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						call R (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						call D_2 (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						call R_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						call D_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						call R (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						
						write(u1,*) "R'"
						write(u1,*) "D"
						write(u1,*) "R"
						write(u1,*) "D2"
						write(u1,*) "R'"
						write(u1,*) "D'"
						write(u1,*) "R"
					
					else if ((MF(2,1) == 'white').or.(MF(2,2) == 'white').or.(MR(2,1) == 'white').or.(MR(2,2) == 'white').or.&
					&(MB(2,1) == 'white').or.(MB(2,2) == 'white').or.(ML(2,1) == 'white').or.(ML(2,2) == 'white')) then
					!El blanco estaria en posicion vertical, en la capa inferior
						
					
						if ((MR(2,2) == 'white').or.(MB(2,1) == 'white')) then
							call D_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
							write(u1,*) "D'"
						else if ((MB(2,2) == 'white').or.(ML(2,1) == 'white')) then
							call D_2 (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
							write(u1,*) "D2"
						else if ((ML(2,2) == 'white').or.(MF(2,1) == 'white')) then
							call D (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
							write(u1,*) "D"						
						end if
						
						if (MR(2,1) =='white') then		!Blanco en cara derecha
							call R_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
							call D_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
							call R (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)	
							
							write(u1,*) "R'"
							write(u1,*) "D'"
							write(u1,*) "R"
						else							!Blanco en cara frontal
							call D_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
							call R_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
							call D (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
							call R (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
							
							write(u1,*) "D'"
							write(u1,*) "R'"
							write(u1,*) "D"
							write(u1,*) "R"
						end if
						
					else			!El blanco est en posicion vertical, en la pieza superior derecha
						
						
						if (MF(1,2) == 'white') then		!Blanco delante
						
							call R_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
							call D (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
							call R (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
							call D_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
							call R_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
							call D (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
							call R (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
							
							write(u1,*) "R'"
							write(u1,*) "D"
							write(u1,*) "R"
							write(u1,*) "D'"
							write(u1,*) "R'"
							write(u1,*) "D"
							write(u1,*) "R"
							
						else if (MR(1,1) == 'white') then	!Blanco a la derecha
						
							call R_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
							call D_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
							call R (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
							call D (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
							call R_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
							call D_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
							call R (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
							
							write(u1,*) "R'"
							write(u1,*) "D'"
							write(u1,*) "R"
							write(u1,*) "D"
							write(u1,*) "R'"
							write(u1,*) "D'"
							write(u1,*) "R"
							
						end if
						
					end if
					
					
					
				end do
				
				
			end if
			
			write (*,*) 'Tras subir los blancos y antes de permutar, las caras quedan:'
	
	write(*,*) '----------------------------'
	write(*,*) 'U'
	do i = 1, 2
		write(*,*) (MU(i,j), j = 1,2)
	end do
	write(*,*) '----------------------------'
	
	write(*,*) '----------------------------'
	write(*,*) 'F'
	do i = 1, 2
		write(*,*) (MF(i,j), j = 1,2)
	end do
	write(*,*) '----------------------------'

	write(*,*) '----------------------------'
	write(*,*) 'R'
	do i = 1, 2
		write(*,*) (MR(i,j), j = 1,2)
	end do
	write(*,*) '----------------------------'
	
	write(*,*) '----------------------------'
	write(*,*) 'B'
	do i = 1, 2
		write(*,*) (MB(i,j), j = 1,2)
	end do
	write(*,*) '----------------------------'
	
	write(*,*) '----------------------------'
	write(*,*) 'L'
	do i = 1, 2
		write(*,*) (ML(i,j), j = 1,2)
	end do
	write(*,*) '----------------------------'
	
	write(*,*) '----------------------------'
	write(*,*) 'D'
	do i = 1, 2
		write(*,*) (MD(i,j), j = 1,2)
	end do
	write(*,*) '----------------------------'
	
	write(*,*) ' '
			
			!------------------------------------------------------------------------------------
			!2 parte; permutacion
			!------------------------------------------------------------------------------------
			
			if ((MF(1,1) == MF(1,2)).and.(MR(1,1) == MR(1,2)).and.(MB(1,1) == MB(1,2)).and.(ML(1,1) == ML(1,2))) then
				A = 0			
			else if (MF(1,1) == MF(1,2)) then		
				A = 1
				call U_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				write(u1,*) "U'"
			else if (MR(1,1) == MR(1,2)) then		
				A = 1
			else if (MB(1,1) == MB(1,2)) then		
				A = 1
				call U (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				write(u1,*) "U"
			else if (ML(1,1) == ML(1,2)) then		
				A = 1
				call U_2 (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				write(u1,*) "U2"
			else 
				A = 2
			end if
			
			if (A == 1) then
			
				call R_2 (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				call B_2 (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				call R (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				call F (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				call R_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				call B_2 (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				call R (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				call F_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				call R (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				
				write(u1,*) "R2"
				write(u1,*) "B2"
				write(u1,*) "R"
				write(u1,*) "F"
				write(u1,*) "R'"
				write(u1,*) "B2"
				write(u1,*) "R"
				write(u1,*) "F'"
				write(u1,*) "R"
				
			else if (A == 2) then
			
				call F (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				call R (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				call U_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				call R_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				call U_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				call R (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				call U (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				call R_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				call F_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				call R (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				call U (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				call R_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				call U_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				call R_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				call F (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				call R (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				call F_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				
				write(u1,*) "F"
				write(u1,*) "R"
				write(u1,*) "U'"
				write(u1,*) "R'"
				write(u1,*) "U'"
				write(u1,*) "R"
				write(u1,*) "U"
				write(u1,*) "R'"
				write(u1,*) "F'"
				write(u1,*) "R"
				write(u1,*) "U"
				write(u1,*) "R'"
				write(u1,*) "U'"
				write(u1,*) "R'"
				write(u1,*) "F"
				write(u1,*) "R"
				write(u1,*) "F'"
				
			end if
			
			write (*,*) 'Despues de la resolucion del primer paso, las caras quedan:'
	
			write(*,*) '----------------------------'
			write(*,*) 'U'
			do i = 1, 2
				write(*,*) (MU(i,j), j = 1,2)
			end do
			write(*,*) '----------------------------'
			
			write(*,*) '----------------------------'
			write(*,*) 'F'
			do i = 1, 2
				write(*,*) (MF(i,j), j = 1,2)
			end do
			write(*,*) '----------------------------'

			write(*,*) '----------------------------'
			write(*,*) 'R'
			do i = 1, 2
				write(*,*) (MR(i,j), j = 1,2)
			end do
			write(*,*) '----------------------------'
			
			write(*,*) '----------------------------'
			write(*,*) 'B'
			do i = 1, 2
				write(*,*) (MB(i,j), j = 1,2)
			end do
			write(*,*) '----------------------------'
			
			write(*,*) '----------------------------'
			write(*,*) 'L'
			do i = 1, 2
				write(*,*) (ML(i,j), j = 1,2)
			end do
			write(*,*) '----------------------------'
			
			write(*,*) '----------------------------'
			write(*,*) 'D'
			do i = 1, 2
				write(*,*) (MD(i,j), j = 1,2)
			end do
			write(*,*) '----------------------------'
			
			write(*,*) ' '
			
			
		end subroutine solve_step_1
	
	!______________________________________________________________________	
		
		subroutine solve_step_2 (MU, MF, MR, MB, ML, MD)
		
			character (len=10), intent(inout)	:: MU(2,2), MF(2,2), MR(2,2), MB(2,2), ML(2,2), MD(2,2)
			
			integer								:: u1, u7, error, i, j, N
			
			
			u1 = 201
			u7 = 202
			
			open (unit = u7, file = "archivos_de_programa/errores.txt", status = 'unknown', action = 'write', iostat = error)
			
			open (unit = u1, file = 'resultados/movimientos_paso_2.txt', status = 'replace', action = 'write', iostat = error)
			if (error > 0) then
				write(u7,*) 'subroutine solve_step_2: el fichero "resultados/movimientos_paso_2.txt" no se ha abierto correctamente'
				stop 'subroutine solve_step_2: el fichero "resultados/movimientos_paso_2.txt" no se ha abierto correctamente'
			end if
			
			!------------------------------------------------------------------------------------
			!giro para situar la cara resuelta debajo
			!------------------------------------------------------------------------------------
			
			call x_2 (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
			write(u1,*) "x2"
			
			!------------------------------------------------------------------------------------
			!orientacion de la ultima capa (OLL)
			!------------------------------------------------------------------------------------
		
			N = count (MU == 'yellow')
			
			select case (N)
			
				case (0)
				
					if ((((MF(1,1) == 'yellow').and.(MF(1,2) == 'yellow')).and.&
					&((MB(1,1) == 'yellow').and.(MB(1,2) == 'yellow'))).or.&
					&(((MR(1,1) == 'yellow').and.(MR(1,2) == 'yellow')).and.&
					&((ML(1,1) == 'yellow').and.(ML(1,2) == 'yellow')))) then
					!amarillos emparejados, opuestos
					
						if (MF(1,1) == 'yellow') then
						
							call R_2 (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
							call U_2 (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
							call R (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
							call U_2 (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
							call R_2 (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
							
							write(u1,*) "R2"
							write(u1,*) "U2"
							write(u1,*) "R"
							write(u1,*) "U2"
							write(u1,*) "R2"
							
						else
						
							call U (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
							
							call R_2 (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
							call U_2 (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
							call R (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
							call U_2 (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
							call R_2 (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
							
							write(u1,*) "U"
							
							write(u1,*) "R2"
							write(u1,*) "U2"
							write(u1,*) "R"
							write(u1,*) "U2"
							write(u1,*) "R2"
							
						end if
						
					else		!solo una pareja de amarillos opuestos
					
						if ((MF(1,1) == 'yellow').and.(MF(1,2) == 'yellow')) then
						
							call U (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
							write(u1,*) "U"
							
						else if ((MR(1,1) == 'yellow').and.(MR(1,2) == 'yellow')) then
						
							call U_2 (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
							write(u1,*) "U2"
							
						else if ((MB(1,1) == 'yellow').and.(MB(1,2) == 'yellow')) then
						
							call U_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
							write(u1,*) "U'"
							
						end if
						
						call F (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						call R (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						call U (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						call R_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						call U_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						call R (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						call U (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						call R_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						call U_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						call F_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						
						write(u1,*) "F"
						write(u1,*) "R"
						write(u1,*) "U"
						write(u1,*) "R'"
						write(u1,*) "U'"
						write(u1,*) "R"
						write(u1,*) "U"
						write(u1,*) "R'"
						write(u1,*) "U'"
						write(u1,*) "F'"
						
					end if
		
				case (1)
				
					if (MU(1,1) == 'yellow') then
						call U_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						write(u1,*) "U'"
					else if (MU(1,2) == 'yellow') then
						call U_2 (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						write(u1,*) "U2"
					else if (MU(2,2) == 'yellow') then
						call U (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						write(u1,*) "U"
					end if
					
					if (MF(1,2) == 'yellow') then			!Amarillo delante
					
						call R (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						call U (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						call R_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						call U (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						call R (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						call U_2 (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						call R_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						
						write(u1,*) "R"
						write(u1,*) "U"
						write(u1,*) "R'"
						write(u1,*) "U"
						write(u1,*) "R"
						write(u1,*) "U2"
						write(u1,*) "R'"
						
					else								!Amarillo a la derecha
					
						call U_2 (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						call R (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						call U_2 (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						call R_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						call U_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						call R (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						call U_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						call R_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						
						write(u1,*) "U2"
						write(u1,*) "R"
						write(u1,*) "U2"
						write(u1,*) "R'"
						write(u1,*) "U'"
						write(u1,*) "R"
						write(u1,*) "U'"
						write(u1,*) "R'"
						
					end if
					
				case (2)
					
					if (MR(1,1) == 'yellow') then						
						call U (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						write(u1,*) "U"
					else if (MB(1,1) == 'yellow') then	
						call U_2 (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						write(u1,*) "U2"							
					else if (ML(1,1) == 'yellow') then						
						call U_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						write(u1,*) "U'"
					end if
						
					if ((MU(1,1) == 'yellow').and.(MU(1,2) == 'yellow')) then
					
						call U (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						
						call F (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						call R (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						call U (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						call R_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						call U_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						call F_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						
						write(u1,*) "U"
						
						write(u1,*) "F"
						write(u1,*) "R"
						write(u1,*) "U"
						write(u1,*) "R'"
						write(u1,*) "U'"
						write(u1,*) "F'"
						
					else if ((MU(1,2) == 'yellow').and.(MU(2,2) == 'yellow')) then
					
						call R (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						call U (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						call R_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						call U_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						call R_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						call F (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						call R (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						call F_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						
						write(u1,*) "R"
						write(u1,*) "U"
						write(u1,*) "R'"
						write(u1,*) "U'"
						write(u1,*) "R'"
						write(u1,*) "F"
						write(u1,*) "R"
						write(u1,*) "F'"
						
					else
					
						call F (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						call R_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						call F_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						call R (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						call U (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						call R (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						call U_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						call R_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
						
						write(u1,*) "F"
						write(u1,*) "R'"
						write(u1,*) "F'"
						write(u1,*) "R"
						write(u1,*) "U"
						write(u1,*) "R"
						write(u1,*) "U'"
						write(u1,*) "R'"
						
					end if
					
			end select
			
			write (*,*) 'Despues de la resolucion del segundo paso, las caras quedan:'
	
			write(*,*) '----------------------------'
			write(*,*) 'U'
			do i = 1, 2
				write(*,*) (MU(i,j), j = 1,2)
			end do
			write(*,*) '----------------------------'
			
			write(*,*) '----------------------------'
			write(*,*) 'F'
			do i = 1, 2
				write(*,*) (MF(i,j), j = 1,2)
			end do
			write(*,*) '----------------------------'

			write(*,*) '----------------------------'
			write(*,*) 'R'
			do i = 1, 2
				write(*,*) (MR(i,j), j = 1,2)
			end do
			write(*,*) '----------------------------'
			
			write(*,*) '----------------------------'
			write(*,*) 'B'
			do i = 1, 2
				write(*,*) (MB(i,j), j = 1,2)
			end do
			write(*,*) '----------------------------'
			
			write(*,*) '----------------------------'
			write(*,*) 'L'
			do i = 1, 2
				write(*,*) (ML(i,j), j = 1,2)
			end do
			write(*,*) '----------------------------'
			
			write(*,*) '----------------------------'
			write(*,*) 'D'
			do i = 1, 2
				write(*,*) (MD(i,j), j = 1,2)
			end do
			write(*,*) '----------------------------'
			
			write(*,*) ' '
			

		end subroutine solve_step_2
		
		subroutine solve_step_3 (MU, MF, MR, MB, ML, MD)
		
			character (len=10), intent(inout)	:: MU(2,2), MF(2,2), MR(2,2), MB(2,2), ML(2,2), MD(2,2)
			
			integer								:: u1, u7, error, i, j, N
			
			
			u1 = 201
			u7 = 202
			
			open (unit = u7, file = "archivos_de_programa/errores.txt", status = 'unknown', action = 'write', iostat = error)
			
			open (unit = u1, file = 'resultados/movimientos_paso_3.txt', status = 'replace', action = 'write', iostat = error)
			if (error > 0) then
				write(u7,*) 'subroutine solve_step_3: el fichero "resultados/movimientos_paso_3.txt" no se ha abierto correctamente'
				stop 'subroutine solve_step_3: el fichero "resultados/movimientos_paso_3.txt" no se ha abierto correctamente'
			end if
			
			if ((MF(1,1) /= MF(1,2)).and.(MR(1,1) /= MR(1,2)).and.(MB(1,1) /= MB(1,2)).and.(ML(1,1) /= ML(1,2))) then
			
				call F (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				call R (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				call U_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				call R_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				call U_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				call R (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				call U (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				call R_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				call F_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)				
			
				call R (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				call U (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				call R_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				call U_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				call R_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				call F (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				call R (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				call F_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				
				write(u1,*) "F"
				write(u1,*) "R"
				write(u1,*) "U'"
				write(u1,*) "R'"
				write(u1,*) "U'"
				write(u1,*) "R"
				write(u1,*) "U"
				write(u1,*) "R'"
				write(u1,*) "F'"
				
				write(u1,*) "R"
				write(u1,*) "U"
				write(u1,*) "R'"
				write(u1,*) "U'"
				write(u1,*) "R'"
				write(u1,*) "F"
				write(u1,*) "R"
				write(u1,*) "F'"
				
				!Giro de la parte superior hasta que las dos mitades del cubo cuadren
				
				if (MF(1,1) == MR(2,1)) then
				
					call U_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
					write(u1,*) "U'"
					
				else if (MF(1,1) == MB(2,1)) then
				
					call U_2 (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
					write(u1,*) "U2"
					
				else if (MF(1,1) == ML(2,1)) then
				
					call U (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
					write(u1,*) "U"
				
				end if
				
			else if ((MF(1,1) == MF(1,2)).and.(MR(1,1) == MR(1,2)).and.(MB(1,1) == MB(1,2)).and.(ML(1,1) == ML(1,2))) then
			
			!Capa superior resuelta; solo habra que girar la capa superior del cubo en el caso de que sea necesario
			
				if (MF(1,1) == MR(2,1)) then
				
					call U_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
					write(u1,*) "U'"
					
				else if (MF(1,1) == MB(2,1)) then
				
					call U_2 (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
					write(u1,*) "U2"
					
				else if (MF(1,1) == ML(2,1)) then
				
					call U (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
					write(u1,*) "U"
				
				end if
				
			else if ((MF(1,1) == MF(1,2)).or.(MR(1,1) == MR(1,2)).or.(MB(1,1) == MB(1,2)).or.(ML(1,1) == ML(1,2))) then
			
				!Colocacion de la pareja de colores coincidentes a la derecha
			
				if (MF(1,1) == MF(1,2)) then
				
					call U_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
					write(u1,*) "U'"
					
				else if (MB(1,1) == MB(1,2)) then
				
					call U (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
					write(u1,*) "U"
					
				else if (ML(1,1) == ML(1,2)) then
				
					call U_2 (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
					write(u1,*) "U2"
					
				end if
				
				call R_2 (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				call B_2 (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				call R (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				call F (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				call R_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				call B_2 (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				call R (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				call F_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				call R (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
				
				write(u1,*) "R2"
				write(u1,*) "B2"
				write(u1,*) "R"
				write(u1,*) "F"
				write(u1,*) "R'"
				write(u1,*) "B2"
				write(u1,*) "R"
				write(u1,*) "F'"
				write(u1,*) "R"
				
				!Giro de la parte superior hasta que las dos mitades del cubo cuadren
				
				if (MF(1,1) == MR(2,1)) then
				
					call U_prime (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
					write(u1,*) "U'"
					
				else if (MF(1,1) == MB(2,1)) then
				
					call U_2 (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
					write(u1,*) "U2"
					
				else if (MF(1,1) == ML(2,1)) then
				
					call U (MU=MU, MF=MF, MR=MR, MB=MB, ML=ML, MD=MD)
					write(u1,*) "U"
				
				end if
				
			

			end if
			
			close (u1)
			
			write (*,*) 'Despues de la resolucion del tercer paso, las caras quedan:'
	
			write(*,*) '----------------------------'
			write(*,*) 'U'
			do i = 1, 2
				write(*,*) (MU(i,j), j = 1,2)
			end do
			write(*,*) '----------------------------'
			
			write(*,*) '----------------------------'
			write(*,*) 'F'
			do i = 1, 2
				write(*,*) (MF(i,j), j = 1,2)
			end do
			write(*,*) '----------------------------'

			write(*,*) '----------------------------'
			write(*,*) 'R'
			do i = 1, 2
				write(*,*) (MR(i,j), j = 1,2)
			end do
			write(*,*) '----------------------------'
			
			write(*,*) '----------------------------'
			write(*,*) 'B'
			do i = 1, 2
				write(*,*) (MB(i,j), j = 1,2)
			end do
			write(*,*) '----------------------------'
			
			write(*,*) '----------------------------'
			write(*,*) 'L'
			do i = 1, 2
				write(*,*) (ML(i,j), j = 1,2)
			end do
			write(*,*) '----------------------------'
			
			write(*,*) '----------------------------'
			write(*,*) 'D'
			do i = 1, 2
				write(*,*) (MD(i,j), j = 1,2)
			end do
			write(*,*) '----------------------------'
			
			write(*,*) ' '
		
		end subroutine solve_step_3
		
		
	!______________________________________________________________________
	
	
	
end module subrutinas_2x2x2_LBL_Fortran_Solver_2	